import { world, BlockPermutation } from '@minecraft/server';

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_place_sculk_sound', {
        beforeOnPlayerPlace: e => {
            const { player } = e;
            player.runCommandAsync("playsound break.sculk @a[r=16] ~ ~ ~ 1 1")
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_place_dark_sculk_sound', {
        beforeOnPlayerPlace: e => {
            const { player } = e;
            player.runCommandAsync("playsound place.dark_sculk @a[r=16] ~ ~ ~ 1 1")
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_place_sculk_vein_sound', {
        beforeOnPlayerPlace: e => {
            const { player } = e;
            player.runCommandAsync("playsound break.sculk_vein @a[r=16] ~ ~ ~ 1 1")
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_place_sculk_shrieker_sound', {
        beforeOnPlayerPlace: e => {
            const { player } = e;
            player.runCommandAsync("playsound break.sculk_shrieker @a[r=16] ~ ~ ~ 1 1")
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_place_sculk_sensor_sound', {
        beforeOnPlayerPlace: e => {
            const { player } = e;
            player.runCommandAsync("playsound break.sculk_sensor @a[r=16] ~ ~ ~ 1 1")
        }
    });
});

//Functions

//BONE SCULK
//Bone Sculk Sensor
world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_place_bone_sculk_sensor', {
        onPlace: e => {
            const { block } = e;
            block.dimension.spawnEntity(('warden_evo:bone_sculk_sensor_inactive'), block.location);
        }
    });
});

//Bone Sculk Shrieker
world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_place_bone_sculk_shrieker', {
        onPlace: e => {
            const { block } = e;
            block.dimension.spawnEntity(('warden_evo:bone_sculk_shrieker_inactive'), block.location);
        }
    });
});

//Bone Sculk Catalyst
world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_place_bone_sculk_catalyst', {
        onPlace: e => {
            const { block } = e;
            block.dimension.spawnEntity(('warden_evo:bone_sculk_catalyst_inactive'), block.location);
        }
    });
});

//DARK SCULK
//Dark Sculk Sensor
world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_place_dark_sculk_sensor', {
        onPlace: e => {
            const { block } = e;
            block.dimension.spawnEntity(('warden_evo:dark_sculk_sensor_inactive'), block.location);
        }
    });
});

//Dark Sculk Shrieker
world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_place_dark_sculk_shrieker', {
        onPlace: e => {
            const { block } = e;
            block.dimension.spawnEntity(('warden_evo:dark_sculk_shrieker_inactive'), block.location);
        }
    });
});

//Dark Sculk Catalyst
world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_place_dark_sculk_catalyst', {
        onPlace: e => {
            const { block } = e;
            block.dimension.spawnEntity(('warden_evo:dark_sculk_catalyst_inactive'), block.location);
        }
    });
});

//HOLLOW SCULK
//Hollow Sculk Sensor
world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_place_hollow_sculk_sensor', {
        onPlace: e => {
            const { block } = e;
            block.dimension.spawnEntity(('warden_evo:hollow_sculk_sensor_inactive'), block.location);
        }
    });
});

//Hollow Sculk Shrieker
world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_place_hollow_sculk_shrieker', {
        onPlace: e => {
            const { block } = e;
            block.dimension.spawnEntity(('warden_evo:hollow_sculk_shrieker_inactive'), block.location);
        }
    });
});

//Hollow Sculk Catalyst
world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_place_hollow_sculk_catalyst', {
        onPlace: e => {
            const { block } = e;
            block.dimension.spawnEntity(('warden_evo:hollow_sculk_catalyst_inactive'), block.location);
        }
    });
});

//Magic Gem Cristal
world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_place_magic_gem_crystal', {
        beforeOnPlayerPlace: e => {
            const { player } = e;
            player.runCommandAsync("playsound place.amethyst_block @a[r=16] ~ ~ ~ 1 1")
        }
    });
});

//Sculk Jaw
world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_place_sculk_jaw_active', {
        onPlace: e => {
            const { block } = e;
            block.dimension.spawnEntity(('warden_evo:sculk_jaw_active'), block.location);
        }
    });
});

//Injured Block
world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_place_injured_block_active', {
        onPlace: e => {
            const { block } = e;
            block.dimension.spawnEntity(('warden_evo:injured_block_active'), block.location);
        }
    });
});